/*
 * THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT. 
 */

#include "mysqlstat.h"
#include "mysqlstat_mib.h"

/*
 * Variable handlers.
 * 
 * An instance handler only hands us one request at a time, unwrapping
 * any eventual GETNEXT requests.  
 */


static int
handle_processTotalCount(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{
    uint32_t        val = process_total_count();

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            snmp_set_var_typed_value(requests->requestvb, ASN_GAUGE,
                                     &val, sizeof(val));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_processTotalCount\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

static int
handle_processActiveCount(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info *reqinfo,
                          netsnmp_request_info *requests)
{
    uint32_t        val = process_active_count();

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            snmp_set_var_typed_value(requests->requestvb, ASN_GAUGE,
                                     &val, sizeof(val));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_processActiveCount\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

static int
handle_processSlaveCount(netsnmp_mib_handler *handler,
                         netsnmp_handler_registration *reginfo,
                         netsnmp_agent_request_info *reqinfo,
                         netsnmp_request_info *requests)
{
    uint32_t        val = process_slave_count();

    switch (reqinfo->mode) {
    case MODE_GET:
        {
            snmp_set_var_typed_value(requests->requestvb, ASN_GAUGE,
                                     &val, sizeof(val));
        }
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_processSlaveCount\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}



static void
replSlaveStatusTable_free(netsnmp_cache * cache, void *vmagic)
{
    netsnmp_tdata  *table = (netsnmp_tdata *) vmagic;
    netsnmp_tdata_row *row;

    while ((row = netsnmp_tdata_row_first(table))) {
        replSlaveStatusTable_entry_free(row->data);
        SNMP_FREE(row->data);
        netsnmp_tdata_remove_and_delete_row(table, row);
    }
}

/** handles requests for the replSlaveStatusTable table */
static int
handle_table_replSlaveStatusTable(netsnmp_mib_handler *handler,
                                  netsnmp_handler_registration *reginfo,
                                  netsnmp_agent_request_info *reqinfo,
                                  netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct replSlaveStatusTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct replSlaveStatusTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_REPLSLAVEIOSTATE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replSlaveIOState,
                                         table_entry->
                                         replSlaveIOState_len);
                break;
            case COLUMN_REPLMASTERLOGFILE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterLogFile,
                                         table_entry->
                                         replMasterLogFile_len);
                break;
            case COLUMN_REPLREADMASTERLOGPOS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           replReadMasterLogPos);
                break;
            case COLUMN_REPLRELAYLOGFILE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replRelayLogFile,
                                         table_entry->
                                         replRelayLogFile_len);
                break;
            case COLUMN_REPLRELAYLOGPOS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->replRelayLogPos);
                break;
            case COLUMN_REPLRELAYMASTERLOGFILE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replRelayMasterLogFile,
                                         table_entry->
                                         replRelayMasterLogFile_len);
                break;
            case COLUMN_REPLSLAVEIORUNNING:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           replSlaveIORunning);
                break;
            case COLUMN_REPLSLAVESQLRUNNING:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           replSlaveSQLRunning);
                break;
            case COLUMN_REPLLASTSQLERRNO:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->replLastSQLErrno);
                break;
            case COLUMN_REPLLASTSQLERROR:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replLastSQLError,
                                         table_entry->
                                         replLastSQLError_len);
                break;
            case COLUMN_REPLLASTIOERRNO:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->replLastIOErrno);
                break;
            case COLUMN_REPLLASTIOERROR:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replLastIOError,
                                         table_entry->replLastIOError_len);
                break;
            case COLUMN_REPLEXECMASTERLOGPOS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           replExecMasterLogPos);
                break;
            case COLUMN_REPLRELAYLOGSPACE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_GAUGE,
                                           table_entry->replRelayLogSpace);
                break;
            case COLUMN_REPLSECONDSBEHINDMASTER:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb,
                                           ASN_TIMETICKS,
                                           table_entry->
                                           replSecondsBehindMaster);
                break;
            case COLUMN_REPLMASTERHOST:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterHost,
                                         table_entry->replMasterHost_len);
                break;
            case COLUMN_REPLMASTERUSER:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterUser,
                                         table_entry->replMasterUser_len);
                break;
            case COLUMN_REPLMASTERPORT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->replMasterPort);
                break;
            case COLUMN_REPLCONNECTRETRY:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb,
                                           ASN_TIMETICKS,
                                           table_entry->replConnectRetry);
                break;
            case COLUMN_REPLREPLICATEDODB:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replReplicateDoDB,
                                         table_entry->
                                         replReplicateDoDB_len);
                break;
            case COLUMN_REPLREPLICATEIGNOREDB:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replReplicateIgnoreDB,
                                         table_entry->
                                         replReplicateIgnoreDB_len);
                break;
            case COLUMN_REPLREPLICATEDOTABLE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replReplicateDoTable,
                                         table_entry->
                                         replReplicateDoTable_len);
                break;
            case COLUMN_REPLREPLICATEIGNORETABLE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replReplicateIgnoreTable,
                                         table_entry->
                                         replReplicateIgnoreTable_len);
                break;
            case COLUMN_REPLREPLICATEWILDDOTABLE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replReplicateWildDoTable,
                                         table_entry->
                                         replReplicateWildDoTable_len);
                break;
            case COLUMN_REPLREPLICATEWILDIGNORETABLE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replReplicateWildIgnoreTable,
                                         table_entry->
                                         replReplicateWildIgnoreTable_len);
                break;
            case COLUMN_REPLSKIPCOUNTER:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_GAUGE,
                                           table_entry->replSkipCounter);
                break;
            case COLUMN_REPLUNTILCONDITION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replUntilCondition,
                                         table_entry->
                                         replUntilCondition_len);
                break;
            case COLUMN_REPLUNTILLOGFILE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replUntilLogFile,
                                         table_entry->
                                         replUntilLogFile_len);
                break;
            case COLUMN_REPLUNTILLOGPOS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replUntilLogPos,
                                         table_entry->replUntilLogPos_len);
                break;
            case COLUMN_REPLMASTERSERVERID:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           replMasterServerId);
                break;
            case COLUMN_REPLMASTERSSLALLOWED:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterSSLAllowed,
                                         table_entry->
                                         replMasterSSLAllowed_len);
                break;
            case COLUMN_REPLMASTERSSLCAFILE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterSSLCAFile,
                                         table_entry->
                                         replMasterSSLCAFile_len);
                break;
            case COLUMN_REPLMASTERSSLCAPATH:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterSSLCAPath,
                                         table_entry->
                                         replMasterSSLCAPath_len);
                break;
            case COLUMN_REPLMASTERSSLCERT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterSSLCert,
                                         table_entry->
                                         replMasterSSLCert_len);
                break;
            case COLUMN_REPLMASTERSSLCIPHER:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterSSLCipher,
                                         table_entry->
                                         replMasterSSLCipher_len);
                break;
            case COLUMN_REPLMASTERSSLKEY:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterSSLKey,
                                         table_entry->
                                         replMasterSSLKey_len);
                break;
            case COLUMN_REPLMASTERSSLVERIFYSERVERCERT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           replMasterSSLVerifyServerCert);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_table_replSlaveStatusTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the replSlaveStatusTable table by defining its contents and how it's structured */
static void
initialize_table_replSlaveStatusTable(void)
{
    const oid       replSlaveStatusTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 9163, 102, 1, 1 };
    const size_t    replSlaveStatusTable_oid_len =
        OID_LENGTH(replSlaveStatusTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("mysqlstat_mib",
                "initializing table replSlaveStatusTable\n"));

    reg =
        netsnmp_create_handler_registration("replSlaveStatusTable",
                                            handle_table_replSlaveStatusTable,
                                            replSlaveStatusTable_oid,
                                            replSlaveStatusTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("replSlaveStatusTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR,
                 "error creating tdata table for replSlaveStatusTable\n");
        return;
    }
    cache = netsnmp_cache_create(mysqlstat_cache_timeout,
                                 replSlaveStatusTable_load,
                                 replSlaveStatusTable_free,
                                 replSlaveStatusTable_oid,
                                 replSlaveStatusTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR,
                 "error creating cache for replSlaveStatusTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR,
                 "error creating table info for replSlaveStatusTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: replSlaveIndex */
                                     0);

    table_info->min_column = COLUMN_REPLSLAVEIOSTATE;
    table_info->max_column = COLUMN_REPLMASTERSSLVERIFYSERVERCERT;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}



static void
replMasterStatusTable_free(netsnmp_cache * cache, void *vmagic)
{
    netsnmp_tdata  *table = (netsnmp_tdata *) vmagic;
    netsnmp_tdata_row *row;

    while ((row = netsnmp_tdata_row_first(table))) {
        replMasterStatusTable_entry_free(row->data);
        SNMP_FREE(row->data);
        netsnmp_tdata_remove_and_delete_row(table, row);
    }
}

/** handles requests for the replMasterStatusTable table */
static int
handle_table_replMasterStatusTable(netsnmp_mib_handler *handler,
                                   netsnmp_handler_registration *reginfo,
                                   netsnmp_agent_request_info *reqinfo,
                                   netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct replMasterStatusTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct replMasterStatusTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_REPLMASTERCURRENTLOGFILE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replMasterCurrentLogFile,
                                         table_entry->
                                         replMasterCurrentLogFile_len);
                break;
            case COLUMN_REPLMASTERCURRENTLOGPOS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_COUNTER,
                                           table_entry->
                                           replMasterCurrentLogPos);
                break;
            case COLUMN_REPLMASTERBINLOGDODB:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->replMasterBinlogDoDB,
                                         table_entry->
                                         replMasterBinlogDoDB_len);
                break;
            case COLUMN_REPLMASTERBINLOGIGNOREDB:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         replMasterBinlogIgnoreDB,
                                         table_entry->
                                         replMasterBinlogIgnoreDB_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_table_replMasterStatusTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the replMasterStatusTable table by defining its contents and how it's structured */
static void
initialize_table_replMasterStatusTable(void)
{
    const oid       replMasterStatusTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 9163, 102, 1, 2 };
    const size_t    replMasterStatusTable_oid_len =
        OID_LENGTH(replMasterStatusTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("mysqlstat_mib",
                "initializing table replMasterStatusTable\n"));

    reg =
        netsnmp_create_handler_registration("replMasterStatusTable",
                                            handle_table_replMasterStatusTable,
                                            replMasterStatusTable_oid,
                                            replMasterStatusTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("replMasterStatusTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR,
                 "error creating tdata table for replMasterStatusTable\n");
        return;
    }
    cache = netsnmp_cache_create(mysqlstat_cache_timeout,
                                 replMasterStatusTable_load,
                                 replMasterStatusTable_free,
                                 replMasterStatusTable_oid,
                                 replMasterStatusTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR,
                 "error creating cache for replMasterStatusTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR,
                 "error creating table info for replMasterStatusTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: replMasterIndex */
                                     0);

    table_info->min_column = COLUMN_REPLMASTERCURRENTLOGFILE;
    table_info->max_column = COLUMN_REPLMASTERBINLOGIGNOREDB;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}



static void
processListTable_free(netsnmp_cache * cache, void *vmagic)
{
    netsnmp_tdata  *table = (netsnmp_tdata *) vmagic;
    netsnmp_tdata_row *row;

    while ((row = netsnmp_tdata_row_first(table))) {
        processListTable_entry_free(row->data);
        SNMP_FREE(row->data);
        netsnmp_tdata_remove_and_delete_row(table, row);
    }
}

/** handles requests for the processListTable table */
static int
handle_table_processListTable(netsnmp_mib_handler *handler,
                              netsnmp_handler_registration *reginfo,
                              netsnmp_agent_request_info *reqinfo,
                              netsnmp_request_info *requests)
{
    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    struct processListTable_entry *table_entry;

    switch (reqinfo->mode) {
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            table_entry = (struct processListTable_entry *)
                netsnmp_tdata_extract_entry(request);
            table_info = netsnmp_extract_table_info(request);

            switch (table_info->colnum) {
            case COLUMN_PROCESSID:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->processID);
                break;
            case COLUMN_PROCESSUSER:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->processUser,
                                         table_entry->processUser_len);
                break;
            case COLUMN_PROCESSHOST:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->processHost,
                                         table_entry->processHost_len);
                break;
            case COLUMN_PROCESSDATABASE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->processDatabase,
                                         table_entry->processDatabase_len);
                break;
            case COLUMN_PROCESSCOMMAND:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->processCommand,
                                         table_entry->processCommand_len);
                break;
            case COLUMN_PROCESSTIME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb,
                                           ASN_TIMETICKS,
                                           table_entry->processTime);
                break;
            case COLUMN_PROCESSSTATE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->processState,
                                         table_entry->processState_len);
                break;
            case COLUMN_PROCESSINFO:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->processInfo,
                                         table_entry->processInfo_len);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_table_processListTable\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;

    }
    return SNMP_ERR_NOERROR;
}

/** Initialize the processListTable table by defining its contents and how it's structured */
static void
initialize_table_processListTable(void)
{
    const oid       processListTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 9163, 102, 2, 1 };
    const size_t    processListTable_oid_len =
        OID_LENGTH(processListTable_oid);
    netsnmp_handler_registration *reg;
    netsnmp_tdata  *table_data;
    netsnmp_table_registration_info *table_info;
    netsnmp_cache  *cache;

    DEBUGMSGTL(("mysqlstat_mib", "initializing table processListTable\n"));

    reg =
        netsnmp_create_handler_registration("processListTable",
                                            handle_table_processListTable,
                                            processListTable_oid,
                                            processListTable_oid_len,
                                            HANDLER_CAN_RONLY);

    table_data = netsnmp_tdata_create_table("processListTable", 0);
    if (!table_data) {
        snmp_log(LOG_ERR,
                 "error creating tdata table for processListTable\n");
        return;
    }
    cache = netsnmp_cache_create(mysqlstat_cache_timeout,
                                 processListTable_load,
                                 processListTable_free,
                                 processListTable_oid,
                                 processListTable_oid_len);
    if (!cache) {
        snmp_log(LOG_ERR, "error creating cache for processListTable\n");
    } else
        cache->magic = (void *) table_data;
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (!table_info) {
        snmp_log(LOG_ERR,
                 "error creating table info for processListTable\n");
        return;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: processIndex */
                                     0);

    table_info->min_column = COLUMN_PROCESSID;
    table_info->max_column = COLUMN_PROCESSINFO;

    netsnmp_tdata_register(reg, table_data, table_info);
    if (cache)
        netsnmp_inject_handler(reg, netsnmp_cache_handler_get(cache));
    /*
     * netsnmp_inject_handler_before(reg, netsnmp_cache_handler_get(cache),
     * TABLE_TDATA_NAME);
     */
}


/** Initializes the mysqlstat_mib.c module */
void
init_mysqlstat_mib(void)
{

    const oid       processTotalCount_oid[] =
        { 1, 3, 6, 1, 4, 1, 9163, 102, 2, 2 };


    const oid       processActiveCount_oid[] =
        { 1, 3, 6, 1, 4, 1, 9163, 102, 2, 3 };


    const oid       processSlaveCount_oid[] =
        { 1, 3, 6, 1, 4, 1, 9163, 102, 2, 4 };


    DEBUGMSGTL(("mysqlstat_mib", "Initializing\n"));

    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("processTotalCount", handle_processTotalCount,
                             processTotalCount_oid,
                             OID_LENGTH(processTotalCount_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("processActiveCount",
                             handle_processActiveCount,
                             processActiveCount_oid,
                             OID_LENGTH(processActiveCount_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("processSlaveCount", handle_processSlaveCount,
                             processSlaveCount_oid,
                             OID_LENGTH(processSlaveCount_oid),
                             HANDLER_CAN_RONLY));

    initialize_table_replSlaveStatusTable();
    initialize_table_replMasterStatusTable();
    initialize_table_processListTable();
}

void
deinit_mysqlstat_mib(void)
{
    /*
     * Nothing 
     */
}

/*
 * Local variables:
 * buffer-read-only: t
 * End:
 * vi: set ro:
 */
